(set-logic AUFLIRA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Real) Real)
(declare-fun f8 () S5)
(declare-fun f9 (S6 Int) Int)
(declare-fun f10 () S6)
(declare-fun f11 (S7 Real) S4)
(declare-fun f12 (S8 Real) S7)
(declare-fun f13 () S8)
(declare-fun f14 () S4)
(declare-fun f15 (Real S9) S1)
(declare-fun f16 () S9)
(declare-fun f17 (Int S10) S1)
(declare-fun f18 () S10)
(declare-fun f19 (S4 S11) S1)
(declare-fun f20 () S11)
(declare-fun f21 (Real) S1)
(declare-fun f22 (Int) S1)
(declare-fun f23 (S4) S1)
(declare-fun f24 (S12 S4) S4)
(declare-fun f25 () S12)
(declare-fun f26 () S8)
(declare-fun f27 (S13 S4) S3)
(declare-fun f28 () S13)
(declare-fun f29 (S14 Int) S3)
(declare-fun f30 () S14)
(declare-fun f31 () S13)
(declare-fun f32 (S12) S1)
(declare-fun f33 (S15 S4) S12)
(declare-fun f34 () S15)
(declare-fun f35 () S12)
(declare-fun f36 (S16 S3) S3)
(declare-fun f37 (S17 Int) S16)
(declare-fun f38 () S17)
(declare-fun f39 (S18 S3) Int)
(declare-fun f40 () S18)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 f4 f5) f6))))
(assert (let ((?v_0 0.0)) (= (f7 f8 ?v_0) ?v_0)))
(assert (= (f9 f10 0) 0))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= ?v_0 ?v0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= (f7 f8 ?v0) ?v_0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int)) (= (= (f9 f10 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Real)) (= (f11 (f12 f13 0.0) ?v0) f6)))
(assert (not (= f14 f6)))
(assert (= (f15 0.0 f16) f1))
(assert (= (f17 0 f18) f1))
(assert (= (f19 f6 f20) f1))
(assert (= (f21 0.0) f1))
(assert (= (f22 0) f1))
(assert (= (f23 f6) f1))
(assert (forall ((?v0 Real)) (= (= (f21 ?v0) f1) (= ?v0 0.0))))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f23 ?v0) f1) (= ?v0 f6))))
(assert (= (f24 f25 f6) f6))
(assert (forall ((?v0 S4)) (= (= (f24 f25 ?v0) f6) (= ?v0 f6))))
(assert (let ((?v_0 0.0)) (= f6 (f11 (f12 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (f24 f25 (f24 f25 ?v0)) ?v0)))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 (f12 f26 ?v0))) (= (f24 f25 (f11 ?v_0 ?v1)) (f11 ?v_0 (- ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f24 f25 ?v0) (f24 f25 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f11 (f12 f26 ?v0) ?v1) f14) (and (= ?v0 0.0) (= ?v1 1.0)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (= (= (f11 (f12 f26 ?v0) ?v1) (f11 (f12 f26 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (= f14 (f11 (f12 f26 0.0) 1.0)))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (= (= (f11 (f12 f26 ?v0) ?v1) f6) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f27 f28 (f11 (f12 f26 ?v0) ?v1)) (f29 f30 0))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f27 f31 (f11 (f12 f26 ?v0) ?v1)) (f29 f30 0))))
(assert (forall ((?v0 S4)) (=> (forall ((?v1 Real) (?v2 Real)) (=> (= ?v0 (f11 (f12 f26 ?v1) ?v2)) false)) false)))
(assert (forall ((?v0 S4)) (exists ((?v1 Real) (?v2 Real)) (= ?v0 (f11 (f12 f13 ?v1) ?v2)))))
(assert (= (f32 f25) f1))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f24 (f33 f34 f14) (f11 (f12 f26 ?v0) ?v1)) (f11 (f12 f26 (- ?v1)) ?v0))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f24 (f33 f34 (f11 (f12 f26 ?v0) ?v1)) f14) (f11 (f12 f26 (- ?v1)) ?v0))))
(assert (= (f24 f25 f14) (f24 f35 f14)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f36 (f37 f38 ?v0) ?v1) (f29 f30 (+ (f39 f40 (f29 f30 ?v0)) (f39 f40 ?v1))))))
(assert (forall ((?v0 S4)) (= (f24 f35 (f24 f35 ?v0)) ?v0)))
(assert (forall ((?v0 Real)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 Real)) (= (f7 f8 (- ?v0)) (f7 f8 ?v0))))
(assert (forall ((?v0 Int)) (= (f9 f10 (- ?v0)) (f9 f10 ?v0))))
(assert (forall ((?v0 S3)) (= (f29 f30 (f39 f40 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f39 f40 (f29 f30 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f39 f40 (f29 f30 ?v0)) 0))))
(check-sat)
(exit)
