(set-logic AUFLIRA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 () S2)
(declare-fun f5 (S5 Int) S3)
(declare-fun f6 () S5)
(declare-fun f7 () S4)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 () S6)
(declare-fun f10 (S7 Real) Real)
(declare-fun f11 () S7)
(declare-fun f12 () S3)
(declare-fun f13 (S8 S4) S2)
(declare-fun f14 () S8)
(declare-fun f15 () S4)
(declare-fun f16 (S9 Real) S4)
(declare-fun f17 () S9)
(declare-fun f18 () S4)
(declare-fun f19 (Int S10) S1)
(declare-fun f20 () S10)
(declare-fun f21 (Real S11) S1)
(declare-fun f22 () S11)
(declare-fun f23 (S4 S12) S1)
(declare-fun f24 () S12)
(declare-fun f25 (S3 S13) S1)
(declare-fun f26 () S13)
(declare-fun f27 (Int) S1)
(declare-fun f28 (Real) S1)
(declare-fun f29 (S4) S1)
(declare-fun f30 (S3) S1)
(declare-fun f31 (S14 S4) S4)
(declare-fun f32 () S14)
(declare-fun f33 (S15 Real) S9)
(declare-fun f34 () S15)
(declare-fun f35 () S3)
(declare-fun f36 (S16 S3) Int)
(declare-fun f37 (S17 Int) S16)
(declare-fun f38 () S17)
(declare-fun f39 (S18 S3) Real)
(declare-fun f40 (S19 Real) S18)
(declare-fun f41 () S19)
(declare-fun f42 (S20 S3) S3)
(declare-fun f43 (S21 S3) S20)
(declare-fun f44 () S21)
(declare-fun f45 (S22 S4) S3)
(declare-fun f46 () S22)
(declare-fun f47 () S16)
(declare-fun f48 () S14)
(declare-fun f49 () S22)
(declare-fun f50 (S13 S3) S1)
(declare-fun f51 (S3) S13)
(declare-fun f52 (S3) S13)
(declare-fun f53 (S23 Int) S6)
(declare-fun f54 () S23)
(declare-fun f55 () S21)
(declare-fun f56 (S24 S4) S14)
(declare-fun f57 () S24)
(declare-fun f58 (S25 Real) S7)
(declare-fun f59 () S25)
(declare-fun f60 (S10 Int) S1)
(declare-fun f61 (S12 S4) S1)
(declare-fun f62 (S11 Real) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 f6 0)) f7)))
(assert (= (f8 f9 1) 1))
(assert (let ((?v_0 1.0)) (= (f10 f11 ?v_0) ?v_0)))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Real)) (let ((?v_0 1.0)) (= (= ?v_0 ?v0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4)) (= (= f7 ?v0) (= ?v0 f7))))
(assert (forall ((?v0 S3)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (forall ((?v0 S3)) (= (f3 (f13 f14 (f3 f4 ?v0)) ?v0) f7)))
(assert (forall ((?v0 S3)) (not (= (f3 f4 ?v0) f15))))
(assert (= (f16 f17 0.0) f7))
(assert (not (= f18 f7)))
(assert (= (f19 1 f20) f1))
(assert (= (f21 1.0 f22) f1))
(assert (= (f23 f7 f24) f1))
(assert (= (f25 f12 f26) f1))
(assert (not (= (f27 1) f1)))
(assert (not (= (f28 1.0) f1)))
(assert (not (= (f29 f7) f1)))
(assert (not (= (f30 f12) f1)))
(assert (= (f31 f32 f7) f7))
(assert (= f7 (f16 (f33 f34 1.0) 0.0)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f16 (f33 f34 ?v0) ?v1) f7) (and (= ?v0 1.0) (= ?v1 0.0)))))
(assert (= (f28 0.0) f1))
(assert (= (f29 f15) f1))
(assert (= (f27 0) f1))
(assert (= (f30 f35) f1))
(assert (not (= f18 f15)))
(assert (= (f21 0.0 f22) f1))
(assert (= (f23 f15 f24) f1))
(assert (= (f19 0 f20) f1))
(assert (= (f25 f35 f26) f1))
(assert (let ((?v_0 0.0)) (= f15 (f16 (f33 f34 ?v_0) ?v_0))))
(assert (= (f31 f32 f15) f15))
(assert (let ((?v_0 0.0)) (= (f10 f11 ?v_0) ?v_0)))
(assert (= (f8 f9 0) 0))
(assert (forall ((?v0 Real)) (= (= (f28 ?v0) f1) (= ?v0 0.0))))
(assert (forall ((?v0 S4)) (= (= (f29 ?v0) f1) (= ?v0 f15))))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f30 ?v0) f1) (= ?v0 f35))))
(assert (forall ((?v0 S4)) (= (f31 f32 (f31 f32 ?v0)) ?v0)))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 (f33 f34 ?v0))) (= (f31 f32 (f16 ?v_0 ?v1)) (f16 ?v_0 (- ?v1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f31 f32 (f3 (f13 f14 ?v0) ?v1)) (f3 (f13 f14 (f31 f32 ?v0)) ?v1))))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= ?v_0 ?v0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4)) (= (= f15 ?v0) (= ?v0 f15))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f35 ?v0) (= ?v0 f35))))
(assert (forall ((?v0 S4)) (= (= (f31 f32 ?v0) f15) (= ?v0 f15))))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= (f10 f11 ?v0) ?v_0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int)) (= (= (f8 f9 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f31 f32 ?v0) (f31 f32 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (= (= (f16 (f33 f34 ?v0) ?v1) f15) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f16 (f33 f34 ?v0) ?v1) f18) (and (= ?v0 0.0) (= ?v1 1.0)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (= (= (f16 (f33 f34 ?v0) ?v1) (f16 (f33 f34 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (= f18 (f16 (f33 f34 0.0) 1.0)))
(assert (not (= 0 1)))
(assert (not (= 0.0 1.0)))
(assert (not (= f15 f7)))
(assert (not (= f35 f12)))
(assert (not (= 1 0)))
(assert (not (= 1.0 0.0)))
(assert (not (= f7 f15)))
(assert (not (= f12 f35)))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 0) ?v0) (ite (= ?v0 (f5 f6 0)) 1 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 0.0)) (= (f39 (f40 f41 ?v_0) ?v0) (ite (= ?v0 (f5 f6 0)) 1.0 ?v_0)))))
(assert (forall ((?v0 S3)) (= (f3 (f13 f14 f15) ?v0) (ite (= ?v0 (f5 f6 0)) f7 f15))))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 f35) ?v0) (ite (= ?v0 (f5 f6 0)) f12 f35))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f45 f46 (f16 (f33 f34 ?v0) ?v1)) (f5 f6 0))))
(assert (forall ((?v0 Int)) (= (f36 (f37 f38 ?v0) (f5 f6 0)) 1)))
(assert (forall ((?v0 Real)) (= (f39 (f40 f41 ?v0) (f5 f6 0)) 1.0)))
(assert (forall ((?v0 S4)) (= (f3 (f13 f14 ?v0) (f5 f6 0)) f7)))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 ?v0) (f5 f6 0)) f12)))
(assert (forall ((?v0 Int)) (= (f36 (f37 f38 ?v0) (f5 f6 0)) 1)))
(assert (forall ((?v0 Real)) (= (f39 (f40 f41 ?v0) (f5 f6 0)) 1.0)))
(assert (forall ((?v0 S4)) (= (f3 (f13 f14 ?v0) (f5 f6 0)) f7)))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 ?v0) (f5 f6 0)) f12)))
(assert (= (f36 (f37 f38 1) (f5 f6 2)) 1))
(assert (let ((?v_0 1.0)) (= (f39 (f40 f41 ?v_0) (f5 f6 2)) ?v_0)))
(assert (= (f3 (f13 f14 f7) (f5 f6 2)) f7))
(assert (= (f42 (f43 f44 f12) (f5 f6 2)) f12))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 1) ?v0) 1)))
(assert (forall ((?v0 S3)) (let ((?v_0 1.0)) (= (f39 (f40 f41 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3)) (= (f3 (f13 f14 f7) ?v0) f7)))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 f12) ?v0) f12)))
(assert (forall ((?v0 S3)) (let ((?v_0 0.0)) (= (f39 (f40 f41 ?v_0) (f5 f6 (+ (f36 f47 ?v0) 1))) ?v_0))))
(assert (forall ((?v0 S3)) (= (f3 (f13 f14 f15) (f5 f6 (+ (f36 f47 ?v0) 1))) f15)))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 0) (f5 f6 (+ (f36 f47 ?v0) 1))) 0)))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 f35) (f5 f6 (+ (f36 f47 ?v0) 1))) f35)))
(assert (let ((?v_0 0.0)) (= (f39 (f40 f41 ?v_0) (f5 f6 2)) ?v_0)))
(assert (= (f3 (f13 f14 f15) (f5 f6 2)) f15))
(assert (= (f36 (f37 f38 0) (f5 f6 2)) 0))
(assert (= (f42 (f43 f44 f35) (f5 f6 2)) f35))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 0.0)) (= (= (f39 (f40 f41 ?v0) ?v1) ?v_0) (and (= ?v0 ?v_0) (not (= ?v1 (f5 f6 0))))))))
(assert (forall ((?v0 S4) (?v1 S3)) (= (= (f3 (f13 f14 ?v0) ?v1) f15) (and (= ?v0 f15) (not (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f36 (f37 f38 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f42 (f43 f44 ?v0) ?v1) f35) (and (= ?v0 f35) (not (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 2))) (= (f36 (f37 f38 (f8 f9 ?v0)) ?v_0) (f36 (f37 f38 ?v0) ?v_0)))))
(assert (forall ((?v0 Real)) (let ((?v_0 (f5 f6 2))) (= (f39 (f40 f41 (f10 f11 ?v0)) ?v_0) (f39 (f40 f41 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f36 (f37 f38 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f13 f14 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Real)) (= (f39 (f40 f41 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f36 (f37 f38 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f42 (f43 f44 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f13 f14 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Real)) (= (f39 (f40 f41 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f36 (f37 f38 ?v0) (f5 f6 2)))) (= (f8 f9 ?v_0) ?v_0))))
(assert (forall ((?v0 Real)) (let ((?v_0 (f39 (f40 f41 ?v0) (f5 f6 2)))) (= (f10 f11 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f8 f9 (f36 (f37 f38 ?v0) ?v1)) (f36 (f37 f38 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 Real) (?v1 S3)) (= (f10 f11 (f39 (f40 f41 ?v0) ?v1)) (f39 (f40 f41 (f10 f11 ?v0)) ?v1))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 0.0)) (=> (not (= ?v0 ?v_0)) (not (= (f39 (f40 f41 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f15)) (not (= (f3 (f13 f14 ?v0) ?v1) f15)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f36 (f37 f38 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= (f39 (f40 f41 ?v0) (f5 f6 2)) ?v_0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S4)) (= (= (f3 (f13 f14 ?v0) (f5 f6 2)) f15) (= ?v0 f15))))
(assert (forall ((?v0 Int)) (= (= (f36 (f37 f38 ?v0) (f5 f6 2)) 0) (= ?v0 0))))
(assert (= (f31 f48 f15) f7))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f45 f49 (f16 (f33 f34 ?v0) ?v1)) (f5 f6 0))))
(assert (forall ((?v0 S4)) (=> (forall ((?v1 Real) (?v2 Real)) (=> (= ?v0 (f16 (f33 f34 ?v1) ?v2)) false)) false)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f37 f38 ?v2))) (=> (<= (f36 f47 ?v0) (f36 f47 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f36 ?v_0 ?v1) (f36 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Real)) (let ((?v_0 (f40 f41 ?v2))) (=> (<= (f36 f47 ?v0) (f36 f47 ?v1)) (=> (<= 0.0 ?v2) (=> (<= ?v2 1.0) (<= (f39 ?v_0 ?v1) (f39 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f44 ?v2))) (=> (<= (f36 f47 ?v0) (f36 f47 ?v1)) (=> (= (f50 (f51 f35) ?v2) f1) (=> (= (f50 (f51 ?v2) f12) f1) (= (f50 (f51 (f42 ?v_0 ?v1)) (f42 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f37 f38 ?v2))) (=> (< (f36 f47 ?v0) (f36 f47 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f36 ?v_0 ?v1) (f36 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Real)) (let ((?v_0 (f40 f41 ?v2))) (=> (< (f36 f47 ?v0) (f36 f47 ?v1)) (=> (< 0.0 ?v2) (=> (< ?v2 1.0) (< (f39 ?v_0 ?v1) (f39 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f44 ?v2))) (=> (< (f36 f47 ?v0) (f36 f47 ?v1)) (=> (= (f50 (f52 f35) ?v2) f1) (=> (= (f50 (f52 ?v2) f12) f1) (= (f50 (f52 (f42 ?v_0 ?v1)) (f42 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f36 (f37 f38 ?v0) (f5 f6 (+ (f36 f47 ?v1) 1))) 1)))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 1.0)) (=> (< 0.0 ?v0) (=> (< ?v0 ?v_0) (< (f39 (f40 f41 ?v0) (f5 f6 (+ (f36 f47 ?v1) 1))) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f52 f35) ?v0) f1) (=> (= (f50 (f52 ?v0) f12) f1) (= (f50 (f52 (f42 (f43 f44 ?v0) (f5 f6 (+ (f36 f47 ?v1) 1)))) f12) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f47 ?v0))) (let ((?v_1 (f53 f54 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f13 f14 (f3 f4 (f5 f6 (f8 ?v_1 (f36 f47 ?v1))))) (f5 f6 (f8 ?v_1 (f36 f47 ?v2)))) (f3 (f13 f14 (f3 f4 ?v1)) ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f43 f44 ?v0))) (= (f42 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) (f5 f6 1) (f5 f6 (f8 (f53 f54 (f36 f47 ?v0)) (f36 f47 (f42 ?v_0 (f5 f6 (- (f36 f47 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f8 (f53 f54 ?v0) (f36 (f37 f38 (f36 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f43 f44 ?v0))) (= (f42 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f42 (f43 f55 ?v0) (f42 (f43 f44 (f42 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f31 (f56 f57 ?v0) (f3 (f13 f14 (f3 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f40 f41 ?v0))) (= (f39 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f10 (f58 f59 ?v0) (f39 (f40 f41 (f39 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (let ((?v_1 (f36 ?v_0 ?v1))) (= (f36 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f8 (f53 f54 ?v0) (f8 (f53 f54 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f43 f44 ?v0))) (let ((?v_1 (f42 ?v_0 ?v1))) (= (f42 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f42 (f43 f55 ?v0) (f42 (f43 f55 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f31 (f56 f57 ?v0) (f31 (f56 f57 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f40 f41 ?v0))) (let ((?v_1 (f39 ?v_0 ?v1))) (= (f39 ?v_0 (f5 f6 (+ (* 2 (f36 f47 ?v1)) 1))) (f10 (f58 f59 ?v0) (f10 (f58 f59 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (let ((?v_1 (f36 ?v_0 ?v1))) (= (f36 ?v_0 (f5 f6 (* 2 (f36 f47 ?v1)))) (f8 (f53 f54 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f43 f44 ?v0))) (let ((?v_1 (f42 ?v_0 ?v1))) (= (f42 ?v_0 (f5 f6 (* 2 (f36 f47 ?v1)))) (f42 (f43 f55 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (* 2 (f36 f47 ?v1)))) (f31 (f56 f57 ?v_1) ?v_1))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f40 f41 ?v0))) (let ((?v_1 (f39 ?v_0 ?v1))) (= (f39 ?v_0 (f5 f6 (* 2 (f36 f47 ?v1)))) (f10 (f58 f59 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 (f37 f38 (f36 ?v_0 ?v1)) ?v2) (f36 ?v_0 (f5 f6 (f8 (f53 f54 (f36 f47 ?v1)) (f36 f47 ?v2))))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (< 0.0 ?v0) (= (<= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (< 0 ?v0) (= (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (< ?v0 0.0) (= (<= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (< ?v0 0) (= (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 0.0)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< ?v_0 ?v1) (=> (<= ?v_0 ?v2) (< (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v3)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f50 (f52 ?v0) ?v1) f1) (=> (= (f50 (f52 ?v2) ?v3) f1) (=> (= (f50 (f52 f35) ?v1) f1) (=> (= (f50 (f51 f35) ?v2) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 0.0)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= ?v_0 ?v0) (=> (<= ?v_0 ?v2) (< (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v3)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f51 f35))) (=> (= (f50 (f52 ?v0) ?v1) f1) (=> (= (f50 (f52 ?v2) ?v3) f1) (=> (= (f50 ?v_0 ?v0) f1) (=> (= (f50 ?v_0 ?v2) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 0.0)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= ?v_0 ?v0) (=> (< ?v_0 ?v2) (< (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v3)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f50 (f52 ?v0) ?v1) f1) (=> (= (f50 (f51 ?v2) ?v3) f1) (=> (= (f50 (f51 f35) ?v0) f1) (=> (= (f50 (f52 f35) ?v2) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S13)) (= (= (f25 ?v0 ?v1) f1) (= (f50 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f19 ?v0 ?v1) f1) (= (f60 ?v1 ?v0) f1))))
(assert (forall ((?v0 S4) (?v1 S12)) (= (= (f23 ?v0 ?v1) f1) (= (f61 ?v1 ?v0) f1))))
(assert (forall ((?v0 Real) (?v1 S11)) (= (= (f21 ?v0 ?v1) f1) (= (f62 ?v1 ?v0) f1))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 0.0)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< ?v_0 ?v0) (=> (<= ?v_0 ?v2) (< (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v3)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f50 (f51 ?v0) ?v1) f1) (=> (= (f50 (f52 ?v2) ?v3) f1) (=> (= (f50 (f52 f35) ?v0) f1) (=> (= (f50 (f51 f35) ?v2) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (< (f10 (f58 f59 ?v0) ?v1) (f10 (f58 f59 ?v2) ?v1)) (=> (<= 0.0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f8 (f53 f54 ?v0) ?v1) (f8 (f53 f54 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f50 (f52 (f42 (f43 f55 ?v0) ?v1)) (f42 (f43 f55 ?v2) ?v1)) f1) (=> (= (f50 (f51 f35) ?v1) f1) (= (f50 (f52 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (< (f10 (f58 f59 ?v0) ?v1) (f10 (f58 f59 ?v2) ?v1)) (=> (<= 0.0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f8 (f53 f54 ?v0) ?v1) (f8 (f53 f54 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f50 (f52 (f42 (f43 f55 ?v0) ?v1)) (f42 (f43 f55 ?v2) ?v1)) f1) (=> (= (f50 (f51 f35) ?v1) f1) (= (f50 (f52 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (< (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (=> (<= 0.0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (< (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v0))) (=> (= (f50 (f52 (f42 ?v_0 ?v1)) (f42 ?v_0 ?v2)) f1) (=> (= (f50 (f51 f35) ?v0) f1) (= (f50 (f52 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (< (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (=> (<= 0.0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (< (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v0))) (=> (= (f50 (f52 (f42 ?v_0 ?v1)) (f42 ?v_0 ?v2)) f1) (=> (= (f50 (f51 f35) ?v0) f1) (= (f50 (f52 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (<= (f10 (f58 f59 ?v0) ?v1) (f10 (f58 f59 ?v2) ?v1)) (=> (< 0.0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f8 (f53 f54 ?v0) ?v1) (f8 (f53 f54 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f50 (f51 (f42 (f43 f55 ?v0) ?v1)) (f42 (f43 f55 ?v2) ?v1)) f1) (=> (= (f50 (f52 f35) ?v1) f1) (= (f50 (f51 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (<= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (=> (< 0.0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v0))) (=> (= (f50 (f51 (f42 ?v_0 ?v1)) (f42 ?v_0 ?v2)) f1) (=> (= (f50 (f52 f35) ?v0) f1) (= (f50 (f51 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f53 f54 ?v0))) (= (f8 (f53 f54 (f8 ?v_0 ?v1)) (f8 (f53 f54 ?v2) ?v3)) (f8 (f53 f54 (f8 ?v_0 ?v2)) (f8 (f53 f54 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f56 f57 ?v0))) (= (f31 (f56 f57 (f31 ?v_0 ?v1)) (f31 (f56 f57 ?v2) ?v3)) (f31 (f56 f57 (f31 ?v_0 ?v2)) (f31 (f56 f57 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f43 f55 ?v0))) (= (f42 (f43 f55 (f42 ?v_0 ?v1)) (f42 (f43 f55 ?v2) ?v3)) (f42 (f43 f55 (f42 ?v_0 ?v2)) (f42 (f43 f55 ?v1) ?v3))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 (f58 f59 ?v0))) (= (f10 (f58 f59 (f10 ?v_0 ?v1)) (f10 (f58 f59 ?v2) ?v3)) (f10 (f58 f59 (f10 ?v_0 ?v2)) (f10 (f58 f59 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f53 f54 (f8 (f53 f54 ?v0) ?v1))) (?v_0 (f53 f54 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f56 f57 (f31 (f56 f57 ?v0) ?v1))) (?v_0 (f56 f57 ?v2))) (= (f31 ?v_1 (f31 ?v_0 ?v3)) (f31 ?v_0 (f31 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f43 f55 (f42 (f43 f55 ?v0) ?v1))) (?v_0 (f43 f55 ?v2))) (= (f42 ?v_1 (f42 ?v_0 ?v3)) (f42 ?v_0 (f42 ?v_1 ?v3))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_1 (f58 f59 (f10 (f58 f59 ?v0) ?v1))) (?v_0 (f58 f59 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f53 f54 ?v0)) (?v_1 (f8 (f53 f54 ?v2) ?v3))) (= (f8 (f53 f54 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f53 f54 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f56 f57 ?v0)) (?v_1 (f31 (f56 f57 ?v2) ?v3))) (= (f31 (f56 f57 (f31 ?v_0 ?v1)) ?v_1) (f31 ?v_0 (f31 (f56 f57 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f43 f55 ?v0)) (?v_1 (f42 (f43 f55 ?v2) ?v3))) (= (f42 (f43 f55 (f42 ?v_0 ?v1)) ?v_1) (f42 ?v_0 (f42 (f43 f55 ?v1) ?v_1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 (f58 f59 ?v0)) (?v_1 (f10 (f58 f59 ?v2) ?v3))) (= (f10 (f58 f59 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f58 f59 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (= (f8 (f53 f54 (f8 ?v_0 ?v1)) ?v2) (f8 (f53 f54 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f56 f57 ?v0))) (= (f31 (f56 f57 (f31 ?v_0 ?v1)) ?v2) (f31 (f56 f57 (f31 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v0))) (= (f42 (f43 f55 (f42 ?v_0 ?v1)) ?v2) (f42 (f43 f55 (f42 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (= (f10 (f58 f59 (f10 ?v_0 ?v1)) ?v2) (f10 (f58 f59 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (= (f8 (f53 f54 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f53 f54 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f56 f57 ?v0))) (= (f31 (f56 f57 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f56 f57 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v0))) (= (f42 (f43 f55 (f42 ?v_0 ?v1)) ?v2) (f42 ?v_0 (f42 (f43 f55 ?v1) ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (= (f10 (f58 f59 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f58 f59 ?v1) ?v2))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f36 f47 ?v0))) (= (f5 f6 (* 2 ?v_0)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (= (f8 ?v_0 (f8 (f53 f54 ?v1) ?v2)) (f8 (f53 f54 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f56 f57 ?v0))) (= (f31 ?v_0 (f31 (f56 f57 ?v1) ?v2)) (f31 (f56 f57 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v0))) (= (f42 ?v_0 (f42 (f43 f55 ?v1) ?v2)) (f42 (f43 f55 (f42 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (= (f10 ?v_0 (f10 (f58 f59 ?v1) ?v2)) (f10 (f58 f59 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f53 f54 ?v0)) (?v_0 (f53 f54 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f56 f57 ?v0)) (?v_0 (f56 f57 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f43 f55 ?v0)) (?v_0 (f43 f55 ?v1))) (= (f42 ?v_1 (f42 ?v_0 ?v2)) (f42 ?v_0 (f42 ?v_1 ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_1 (f58 f59 ?v0)) (?v_0 (f58 f59 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f36 f47 ?v0))) (= (f5 f6 (* ?v_0 2)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f5 f6 0)) (?v_2 (f36 f47 ?v0)) (?v_1 (f36 f47 ?v1))) (= (f5 f6 (f8 (f53 f54 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f5 f6 (+ ?v_1 (f8 (f53 f54 (f36 f47 (f5 f6 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f53 f54 ?v0) ?v1) (f8 (f53 f54 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f31 (f56 f57 ?v0) ?v1) (f31 (f56 f57 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f42 (f43 f55 ?v0) ?v1) (f42 (f43 f55 ?v1) ?v0))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f10 (f58 f59 ?v0) ?v1) (f10 (f58 f59 ?v1) ?v0))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0.0) (< (f10 ?v_0 ?v1) (f10 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (< ?v0 ?v1) (=> (< ?v2 0.0) (< (f10 (f58 f59 ?v1) ?v2) (f10 (f58 f59 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f8 (f53 f54 ?v1) ?v2) (f8 (f53 f54 ?v0) ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v2))) (=> (< ?v0 ?v1) (=> (< 0.0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v2))) (=> (= (f50 (f52 ?v0) ?v1) f1) (=> (= (f50 (f52 f35) ?v2) f1) (= (f50 (f52 (f42 ?v_0 ?v0)) (f42 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v2))) (=> (< ?v0 ?v1) (=> (< 0.0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v2))) (=> (= (f50 (f52 ?v0) ?v1) f1) (=> (= (f50 (f52 f35) ?v2) f1) (= (f50 (f52 (f42 ?v_0 ?v0)) (f42 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (< ?v0 ?v1) (=> (< 0.0 ?v2) (< (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f50 (f52 ?v0) ?v1) f1) (=> (= (f50 (f52 f35) ?v2) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v0 ?v_0) (=> (< ?v1 ?v_0) (< ?v_0 (f10 (f58 f59 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f8 (f53 f54 ?v0) ?v1))))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v0 ?v_0) (=> (< ?v_0 ?v1) (< (f10 (f58 f59 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f8 (f53 f54 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f52 ?v0) f35) f1) (=> (= (f50 (f52 f35) ?v1) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v1)) f35) f1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (< ?v0 0.0) (= (< (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (< ?v0 0) (= (< (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v_0 (f10 (f58 f59 ?v0) ?v1)) (=> (< ?v_0 ?v1) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f8 (f53 f54 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f52 f35))) (=> (= (f50 ?v_0 (f42 (f43 f55 ?v0) ?v1)) f1) (=> (= (f50 ?v_0 ?v1) f1) (= (f50 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v_0 (f10 (f58 f59 ?v0) ?v1)) (=> (< ?v_0 ?v0) (< ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f8 (f53 f54 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f52 f35))) (=> (= (f50 ?v_0 (f42 (f43 f55 ?v0) ?v1)) f1) (=> (= (f50 ?v_0 ?v0) f1) (= (f50 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v_0 ?v0) (=> (< ?v1 ?v_0) (< (f10 (f58 f59 ?v1) ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f8 (f53 f54 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f52 f35) ?v0) f1) (=> (= (f50 (f52 ?v1) f35) f1) (= (f50 (f52 (f42 (f43 f55 ?v1) ?v0)) f35) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v_0 ?v0) (=> (< ?v1 ?v_0) (< (f10 (f58 f59 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f8 (f53 f54 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f52 f35) ?v0) f1) (=> (= (f50 (f52 ?v1) f35) f1) (= (f50 (f52 (f42 (f43 f55 ?v0) ?v1)) f35) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (< ?v_0 ?v0) (=> (< ?v_0 ?v1) (< ?v_0 (f10 (f58 f59 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f8 (f53 f54 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f52 f35))) (=> (= (f50 ?v_0 ?v0) f1) (=> (= (f50 ?v_0 ?v1) f1) (= (f50 ?v_0 (f42 (f43 f55 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v0))) (=> (< 0.0 ?v0) (= (< (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (=> (< 0 ?v0) (= (< (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_1 0.0) (?v_0 (f58 f59 ?v0))) (= (< (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (or (and (< ?v_1 ?v0) (< ?v1 ?v2)) (and (< ?v0 ?v_1) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v0))) (= (< (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 0.0)) (= (< (f10 (f58 f59 ?v0) ?v1) (f10 (f58 f59 ?v2) ?v1)) (or (and (< ?v_0 ?v1) (< ?v0 ?v2)) (and (< ?v1 ?v_0) (< ?v2 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f8 (f53 f54 ?v0) ?v1) (f8 (f53 f54 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Real)) (not (< (f10 (f58 f59 ?v0) ?v0) 0.0))))
(assert (forall ((?v0 Int)) (not (< (f8 (f53 f54 ?v0) ?v0) 0))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (or (and (<= ?v_0 ?v0) (<= ?v1 ?v_0)) (and (<= ?v0 ?v_0) (<= ?v_0 ?v1))) (<= (f10 (f58 f59 ?v0) ?v1) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f8 (f53 f54 ?v0) ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f51 f35))) (=> (or (and (= (f50 ?v_0 ?v0) f1) (= (f50 (f51 ?v1) f35) f1)) (and (= (f50 (f51 ?v0) f35) f1) (= (f50 ?v_0 ?v1) f1))) (= (f50 (f51 (f42 (f43 f55 ?v0) ?v1)) f35) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (and (or (<= ?v_0 ?v0) (<= ?v0 ?v_0)) (or (<= ?v_0 ?v1) (<= ?v1 ?v_0))) (= (f10 f11 (f10 (f58 f59 ?v0) ?v1)) (f10 (f58 f59 (f10 f11 ?v0)) (f10 f11 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f8 f9 (f8 (f53 f54 ?v0) ?v1)) (f8 (f53 f54 (f8 f9 ?v0)) (f8 f9 ?v1))))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (or (and (<= ?v_0 ?v0) (<= ?v_0 ?v1)) (and (<= ?v0 ?v_0) (<= ?v1 ?v_0))) (<= ?v_0 (f10 (f58 f59 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f8 (f53 f54 ?v0) ?v1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 0.0)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= ?v_0 ?v1) (=> (<= ?v_0 ?v2) (<= (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v3)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f51 f35))) (=> (= (f50 (f51 ?v0) ?v1) f1) (=> (= (f50 (f51 ?v2) ?v3) f1) (=> (= (f50 ?v_0 ?v1) f1) (=> (= (f50 ?v_0 ?v2) f1) (= (f50 (f51 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 0.0)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= ?v_0 ?v0) (=> (<= ?v_0 ?v2) (<= (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v3)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f51 f35))) (=> (= (f50 (f51 ?v0) ?v1) f1) (=> (= (f50 (f51 ?v2) ?v3) f1) (=> (= (f50 ?v_0 ?v0) f1) (=> (= (f50 ?v_0 ?v2) f1) (= (f50 (f51 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0.0) (<= (f10 ?v_0 ?v1) (f10 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0.0) (<= (f10 (f58 f59 ?v1) ?v2) (f10 (f58 f59 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f8 (f53 f54 ?v1) ?v2) (f8 (f53 f54 ?v0) ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0.0 ?v2) (<= (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v2))) (=> (= (f50 (f51 ?v0) ?v1) f1) (=> (= (f50 (f51 f35) ?v2) f1) (= (f50 (f51 (f42 ?v_0 ?v0)) (f42 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f58 f59 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0.0 ?v2) (<= (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f53 f54 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f43 f55 ?v2))) (=> (= (f50 (f51 ?v0) ?v1) f1) (=> (= (f50 (f51 f35) ?v2) f1) (= (f50 (f51 (f42 ?v_0 ?v0)) (f42 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (=> (<= ?v0 ?v1) (=> (<= 0.0 ?v2) (<= (f10 (f58 f59 ?v0) ?v2) (f10 (f58 f59 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f8 (f53 f54 ?v0) ?v2) (f8 (f53 f54 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f50 (f51 ?v0) ?v1) f1) (=> (= (f50 (f51 f35) ?v2) f1) (= (f50 (f51 (f42 (f43 f55 ?v0) ?v2)) (f42 (f43 f55 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (<= ?v0 ?v_0) (=> (<= ?v1 ?v_0) (<= ?v_0 (f10 (f58 f59 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f8 (f53 f54 ?v0) ?v1))))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (<= ?v0 ?v_0) (=> (<= ?v_0 ?v1) (<= (f10 (f58 f59 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f8 (f53 f54 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f51 ?v0) f35) f1) (=> (= (f50 (f51 f35) ?v1) f1) (= (f50 (f51 (f42 (f43 f55 ?v0) ?v1)) f35) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (<= ?v_0 ?v0) (=> (<= ?v1 ?v_0) (<= (f10 (f58 f59 ?v1) ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f8 (f53 f54 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f51 f35) ?v0) f1) (=> (= (f50 (f51 ?v1) f35) f1) (= (f50 (f51 (f42 (f43 f55 ?v1) ?v0)) f35) f1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (<= ?v_0 ?v0) (=> (<= ?v1 ?v_0) (<= (f10 (f58 f59 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f8 (f53 f54 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f50 (f51 f35) ?v0) f1) (=> (= (f50 (f51 ?v1) f35) f1) (= (f50 (f51 (f42 (f43 f55 ?v0) ?v1)) f35) f1)))))
(assert (forall ((?v0 S3)) (= (f5 f6 (f36 f47 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f36 f47 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f36 f47 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
