(set-logic AUFLIRA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 () S2)
(declare-fun f5 (S5 Int) S3)
(declare-fun f6 () S5)
(declare-fun f7 (S6 Real) S4)
(declare-fun f8 (S7 Real) S6)
(declare-fun f9 () S7)
(declare-fun f10 (S8 S4) S3)
(declare-fun f11 () S8)
(declare-fun f12 () S8)
(declare-fun f13 () S4)
(declare-fun f14 () S4)
(declare-fun f15 () S4)
(declare-fun f16 (S9 S4) S4)
(declare-fun f17 () S9)
(declare-fun f18 (S10 Int) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Real) Real)
(declare-fun f21 () S11)
(declare-fun f22 (S12 S4) S2)
(declare-fun f23 () S12)
(declare-fun f24 (S13 S4) S9)
(declare-fun f25 () S13)
(declare-fun f26 (S14 Int) S10)
(declare-fun f27 () S14)
(declare-fun f28 (S15 Real) S11)
(declare-fun f29 () S15)
(declare-fun f30 (S16 S3) Int)
(declare-fun f31 () S16)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 f6 2)) (f7 (f8 f9 (- 1.0)) 0.0))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (= (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f10 f11 (f7 (f8 f9 ?v0) ?v1)) (f5 f6 0))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f10 f12 (f7 (f8 f9 ?v0) ?v1)) (f5 f6 0))))
(assert (forall ((?v0 S4)) (=> (forall ((?v1 Real) (?v2 Real)) (=> (= ?v0 (f7 (f8 f9 ?v1) ?v2)) false)) false)))
(assert (forall ((?v0 S3)) (not (= (f3 f4 ?v0) f13))))
(assert (= (f3 f4 (f5 f6 1)) f14))
(assert (= (f3 f4 (f5 f6 0)) f14))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f7 (f8 f9 ?v0) ?v1) f15) (and (= ?v0 0.0) (= ?v1 1.0)))))
(assert (= f15 (f7 (f8 f9 0.0) 1.0)))
(assert (let ((?v_0 0.0)) (= f13 (f7 (f8 f9 ?v_0) ?v_0))))
(assert (not (= f15 f14)))
(assert (not (= f15 f13)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f7 (f8 f9 ?v0) ?v1) f14) (and (= ?v0 1.0) (= ?v1 0.0)))))
(assert (= f14 (f7 (f8 f9 1.0) 0.0)))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (= (= (f7 (f8 f9 ?v0) ?v1) f13) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (not (= 1 0)))
(assert (not (= f14 f13)))
(assert (not (= 1.0 0.0)))
(assert (not (= 0 1)))
(assert (not (= f13 f14)))
(assert (not (= 0.0 1.0)))
(assert (= (f16 f17 f13) f14))
(assert (= (f18 f19 1) 1))
(assert (let ((?v_0 1.0)) (= (f20 f21 ?v_0) ?v_0)))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S4)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 Real)) (let ((?v_0 1.0)) (= (= ?v_0 ?v0) (= ?v0 ?v_0)))))
(assert (let ((?v_0 0.0)) (= (f20 f21 ?v_0) ?v_0)))
(assert (= (f18 f19 0) 0))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= ?v_0 ?v0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f13 ?v0) (= ?v0 f13))))
(assert (forall ((?v0 Real)) (let ((?v_0 0.0)) (= (= (f20 f21 ?v0) ?v_0) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int)) (= (= (f18 f19 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f3 (f22 f23 (f3 f4 ?v0)) ?v0) f14)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f16 (f24 f25 f15) (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 (- ?v1)) ?v0))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f16 (f24 f25 (f7 (f8 f9 ?v0) ?v1)) f15) (f7 (f8 f9 (- ?v1)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f26 f27 ?v0))) (= (f18 (f26 f27 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f28 f29 ?v0))) (= (f20 (f28 f29 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f28 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f24 f25 ?v0))) (= (f16 (f24 f25 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f19 ?v0))) (= (f18 (f26 f27 ?v_0) ?v_0) (f18 (f26 f27 ?v0) ?v0)))))
(assert (forall ((?v0 Real)) (let ((?v_0 (f20 f21 ?v0))) (= (f20 (f28 f29 ?v_0) ?v_0) (f20 (f28 f29 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f19 (f18 (f26 f27 ?v0) ?v1)) (f18 (f26 f27 (f18 f19 ?v0)) (f18 f19 ?v1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f20 f21 (f20 (f28 f29 ?v0) ?v1)) (f20 (f28 f29 (f20 f21 ?v0)) (f20 f21 ?v1)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (=> (= (f20 (f28 f29 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 (f26 f27 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f16 (f24 f25 ?v0) ?v1) f13) (or (= ?v0 f13) (= ?v1 f13)))))
(assert (forall ((?v0 S3)) (= (f5 f6 (f30 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f30 f31 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f30 f31 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
