(set-logic AUFLIRA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 () S2)
(declare-fun f5 (S5 Int) S3)
(declare-fun f6 () S5)
(declare-fun f7 () S4)
(declare-fun f8 () S4)
(declare-fun f9 () S4)
(declare-fun f10 (S6 Real) S4)
(declare-fun f11 (S7 Real) S6)
(declare-fun f12 () S7)
(declare-fun f13 (S8 Int) S4)
(declare-fun f14 () S8)
(declare-fun f15 (S9 S4) Real)
(declare-fun f16 () S9)
(declare-fun f17 () S9)
(declare-fun f18 (S10 S3) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 S4) S2)
(declare-fun f21 () S11)
(declare-fun f22 (S12 Int) Int)
(declare-fun f23 (S13 Int) S12)
(declare-fun f24 () S13)
(declare-fun f25 (S14 S3) S3)
(declare-fun f26 (S15 S3) S14)
(declare-fun f27 () S15)
(declare-fun f28 () S15)
(declare-fun f29 (S16 S4) S4)
(declare-fun f30 (S17 S4) S16)
(declare-fun f31 () S17)
(declare-fun f32 (S18 S3) Real)
(declare-fun f33 (S19 Real) S18)
(declare-fun f34 () S19)
(declare-fun f35 (S20 Real) Real)
(declare-fun f36 (S21 Real) S20)
(declare-fun f37 () S21)
(declare-fun f38 (S22 Int) S10)
(declare-fun f39 () S22)
(declare-fun f40 () S3)
(declare-fun f41 () S5)
(declare-fun f42 (S23 Int) Real)
(declare-fun f43 () S23)
(declare-fun f44 () S12)
(declare-fun f45 () S3)
(declare-fun f46 (S24 S4) S3)
(declare-fun f47 () S24)
(declare-fun f48 () S12)
(declare-fun f49 () S20)
(assert (not (= f1 f2)))
(assert (not (= (f3 f4 (f5 f6 4)) f7)))
(assert (forall ((?v0 S3)) (not (= (f3 f4 ?v0) f8))))
(assert (= (f3 f4 (f5 f6 1)) f9))
(assert (= (f3 f4 (f5 f6 0)) f9))
(assert (= (f3 f4 (f5 f6 2)) (f10 (f11 f12 (- 1.0)) 0.0)))
(assert (not (= f7 f8)))
(assert (not (= f7 f9)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f10 (f11 f12 ?v0) ?v1) f7) (and (= ?v0 0.0) (= ?v1 1.0)))))
(assert (= f7 (f10 (f11 f12 0.0) 1.0)))
(assert (forall ((?v0 Int)) (not (= f7 (f13 f14 ?v0)))))
(assert (= (f15 f16 f7) 1.0))
(assert (= (f15 f17 f7) 0.0))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 f19 ?v0))) (let ((?v_1 (f23 f24 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f20 f21 (f3 f4 (f5 f6 (f22 ?v_1 (f18 f19 ?v1))))) (f5 f6 (f22 ?v_1 (f18 f19 ?v2)))) (f3 (f20 f21 (f3 f4 ?v1)) ?v2)))))))
(assert (= f9 (f10 (f11 f12 1.0) 0.0)))
(assert (let ((?v_0 0.0)) (= f8 (f10 (f11 f12 ?v_0) ?v_0))))
(assert (= (f15 f16 f9) 0.0))
(assert (= (f15 f16 f8) 0.0))
(assert (= (f15 f17 f9) 1.0))
(assert (= (f15 f17 f8) 0.0))
(assert (forall ((?v0 Int)) (= (f15 f16 (f13 f14 ?v0)) 0.0)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f15 f16 (f10 (f11 f12 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f15 f17 (f10 (f11 f12 ?v0) ?v1)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 ?v1) (and (= (f15 f17 ?v0) (f15 f17 ?v1)) (= (f15 f16 ?v0) (f15 f16 ?v1))))))
(assert (forall ((?v0 S4)) (= (f10 (f11 f12 (f15 f17 ?v0)) (f15 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Real) (?v1 Real)) (= (= (f10 (f11 f12 ?v0) ?v1) f9) (and (= ?v0 1.0) (= ?v1 0.0)))))
(assert (forall ((?v0 Real) (?v1 Real)) (let ((?v_0 0.0)) (= (= (f10 (f11 f12 ?v0) ?v1) f8) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (= (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 f17 ?v0) (f15 f17 ?v1)) (=> (= (f15 f16 ?v0) (f15 f16 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3)) (= (f3 (f20 f21 (f3 f4 ?v0)) ?v0) f9)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f25 (f26 f28 ?v0) (f25 (f26 f27 (f25 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f29 (f30 f31 ?v0) (f3 (f20 f21 (f3 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f35 (f36 f37 ?v0) (f32 (f33 f34 (f32 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (= (f18 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f22 (f23 f24 ?v0) (f18 (f38 f39 (f18 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f25 (f26 f28 ?v0) (f25 (f26 f28 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f29 (f30 f31 ?v0) (f29 (f30 f31 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f33 f34 ?v0))) (let ((?v_1 (f32 ?v_0 ?v1))) (= (f32 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f35 (f36 f37 ?v0) (f35 (f36 f37 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (let ((?v_1 (f18 ?v_0 ?v1))) (= (f18 ?v_0 (f5 f6 (+ (* 2 (f18 f19 ?v1)) 1))) (f22 (f23 f24 ?v0) (f22 (f23 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f25 (f26 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f29 (f30 f31 ?v_1) ?v_1))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f33 f34 ?v0))) (let ((?v_1 (f32 ?v_0 ?v1))) (= (f32 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f35 (f36 f37 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (let ((?v_1 (f18 ?v_0 ?v1))) (= (f18 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f22 (f23 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) 1.0 (f35 (f36 f37 ?v0) (f32 ?v_0 (f5 f6 (- (f18 f19 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) f9 (f29 (f30 f31 ?v0) (f3 ?v_0 (f5 f6 (- (f18 f19 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (= (f18 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) 1 (f22 (f23 f24 ?v0) (f18 ?v_0 (f5 f6 (- (f18 f19 ?v1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) f40 (f25 (f26 f28 ?v0) (f25 ?v_0 (f5 f6 (- (f18 f19 ?v1) 1)))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f41 ?v0))) (= (f25 (f26 f27 ?v_0) (f5 f6 2)) (f25 (f26 f28 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f3 (f20 f21 ?v_0) (f5 f6 2)) (f29 (f30 f31 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f42 f43 ?v0))) (= (f32 (f33 f34 ?v_0) (f5 f6 2)) (f35 (f36 f37 ?v_0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 f44 ?v0))) (= (f18 (f38 f39 ?v_0) (f5 f6 2)) (f22 (f23 f24 ?v_0) ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 0.0)) (= (f32 (f33 f34 ?v_0) ?v0) (ite (= ?v0 (f5 f6 0)) 1.0 ?v_0)))))
(assert (forall ((?v0 S3)) (= (f3 (f20 f21 f8) ?v0) (ite (= ?v0 (f5 f6 0)) f9 f8))))
(assert (forall ((?v0 S3)) (= (f18 (f38 f39 0) ?v0) (ite (= ?v0 (f5 f6 0)) 1 0))))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 f45) ?v0) (ite (= ?v0 (f5 f6 0)) f40 f45))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f46 f47 (f10 (f11 f12 ?v0) ?v1)) (f5 f6 0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f5 f6 (f22 (f23 f24 (f18 f19 ?v1)) (f18 f19 ?v2)))) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S3) (?v2 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f5 f6 (f22 (f23 f24 (f18 f19 ?v1)) (f18 f19 ?v2)))) (f3 (f20 f21 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f38 f39 ?v0))) (= (f18 ?v_0 (f5 f6 (f22 (f23 f24 (f18 f19 ?v1)) (f18 f19 ?v2)))) (f18 (f38 f39 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Real) (?v1 S3) (?v2 S3)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f5 f6 (f22 (f23 f24 (f18 f19 ?v1)) (f18 f19 ?v2)))) (f32 (f33 f34 (f32 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f25 (f26 f27 (f25 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 S4) (?v1 S3)) (let ((?v_0 (f20 f21 ?v0))) (= (f3 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f3 (f20 f21 (f3 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f38 f39 ?v0))) (= (f18 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f18 (f38 f39 (f18 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 Real) (?v1 S3)) (let ((?v_0 (f33 f34 ?v0))) (= (f32 ?v_0 (f5 f6 (* 2 (f18 f19 ?v1)))) (f32 (f33 f34 (f32 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_1 (f36 f37 ?v1)) (?v_0 (f36 f37 ?v0))) (= (f29 (f30 f31 (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 ?v2) ?v3)) (f10 (f11 f12 (- (f35 ?v_0 ?v2) (f35 ?v_1 ?v3))) (+ (f35 ?v_0 ?v3) (f35 ?v_1 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) (f5 f6 1) (f5 f6 (f22 (f23 f24 (f18 f19 ?v0)) (f18 f19 (f25 ?v_0 (f5 f6 (- (f18 f19 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 f17 (f29 (f30 f31 ?v0) ?v1)) (- (f35 (f36 f37 (f15 f17 ?v0)) (f15 f17 ?v1)) (f35 (f36 f37 (f15 f16 ?v0)) (f15 f16 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 f16 (f29 (f30 f31 ?v0) ?v1)) (+ (f35 (f36 f37 (f15 f17 ?v0)) (f15 f16 ?v1)) (f35 (f36 f37 (f15 f16 ?v0)) (f15 f17 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_2 (f36 f37 (f15 f16 ?v0))) (?v_1 (f15 f16 ?v1)) (?v_0 (f36 f37 (f15 f17 ?v0))) (?v_3 (f15 f17 ?v1))) (= (f29 (f30 f31 ?v0) ?v1) (f10 (f11 f12 (- (f35 ?v_0 ?v_3) (f35 ?v_2 ?v_1))) (+ (f35 ?v_0 ?v_1) (f35 ?v_2 ?v_3)))))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f29 (f30 f31 (f10 (f11 f12 ?v0) ?v1)) f7) (f10 (f11 f12 (- ?v1)) ?v0))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f29 (f30 f31 f7) (f10 (f11 f12 ?v0) ?v1)) (f10 (f11 f12 (- ?v1)) ?v0))))
(assert (forall ((?v0 Int)) (= (f15 f17 (f13 f14 ?v0)) (f42 f43 ?v0))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Int)) (= (= (f10 (f11 f12 ?v0) ?v1) (f13 f14 ?v2)) (and (= ?v0 (f42 f43 ?v2)) (= ?v1 0.0)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f37 (f35 ?v_0 ?v1)) (f35 (f36 f37 ?v2) ?v3)) (f35 (f36 f37 (f35 ?v_0 ?v2)) (f35 (f36 f37 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) (f29 (f30 f31 ?v2) ?v3)) (f29 (f30 f31 (f29 ?v_0 ?v2)) (f29 (f30 f31 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) (f22 (f23 f24 ?v2) ?v3)) (f22 (f23 f24 (f22 ?v_0 ?v2)) (f22 (f23 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f26 f28 ?v0))) (= (f25 (f26 f28 (f25 ?v_0 ?v1)) (f25 (f26 f28 ?v2) ?v3)) (f25 (f26 f28 (f25 ?v_0 ?v2)) (f25 (f26 f28 ?v1) ?v3))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_1 (f36 f37 (f35 (f36 f37 ?v0) ?v1))) (?v_0 (f36 f37 ?v2))) (= (f35 ?v_1 (f35 ?v_0 ?v3)) (f35 ?v_0 (f35 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f30 f31 (f29 (f30 f31 ?v0) ?v1))) (?v_0 (f30 f31 ?v2))) (= (f29 ?v_1 (f29 ?v_0 ?v3)) (f29 ?v_0 (f29 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f23 f24 (f22 (f23 f24 ?v0) ?v1))) (?v_0 (f23 f24 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f26 f28 (f25 (f26 f28 ?v0) ?v1))) (?v_0 (f26 f28 ?v2))) (= (f25 ?v_1 (f25 ?v_0 ?v3)) (f25 ?v_0 (f25 ?v_1 ?v3))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real) (?v3 Real)) (let ((?v_0 (f36 f37 ?v0)) (?v_1 (f35 (f36 f37 ?v2) ?v3))) (= (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v_1) (f35 ?v_0 (f35 (f36 f37 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f30 f31 ?v0)) (?v_1 (f29 (f30 f31 ?v2) ?v3))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v_1) (f29 ?v_0 (f29 (f30 f31 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f22 (f23 f24 ?v2) ?v3))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f23 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f26 f28 ?v0)) (?v_1 (f25 (f26 f28 ?v2) ?v3))) (= (f25 (f26 f28 (f25 ?v_0 ?v1)) ?v_1) (f25 ?v_0 (f25 (f26 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2) (f35 (f36 f37 (f35 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 (f30 f31 (f29 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 (f23 f24 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f28 ?v0))) (= (f25 (f26 f28 (f25 ?v_0 ?v1)) ?v2) (f25 (f26 f28 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2) (f35 ?v_0 (f35 (f36 f37 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f29 (f30 f31 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f28 ?v0))) (= (f25 (f26 f28 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f35 (f36 f37 ?v1) ?v2)) (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f30 f31 ?v0))) (= (f29 ?v_0 (f29 (f30 f31 ?v1) ?v2)) (f29 (f30 f31 (f29 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f22 (f23 f24 ?v1) ?v2)) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f26 f28 ?v0))) (= (f25 ?v_0 (f25 (f26 f28 ?v1) ?v2)) (f25 (f26 f28 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Real) (?v1 Real) (?v2 Real)) (let ((?v_1 (f36 f37 ?v0)) (?v_0 (f36 f37 ?v1))) (= (f35 ?v_1 (f35 ?v_0 ?v2)) (f35 ?v_0 (f35 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f30 f31 ?v0)) (?v_0 (f30 f31 ?v1))) (= (f29 ?v_1 (f29 ?v_0 ?v2)) (f29 ?v_0 (f29 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f23 f24 ?v0)) (?v_0 (f23 f24 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f26 f28 ?v0)) (?v_0 (f26 f28 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 Real) (?v1 Real)) (= (f35 (f36 f37 ?v0) ?v1) (f35 (f36 f37 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f29 (f30 f31 ?v0) ?v1) (f29 (f30 f31 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 (f23 f24 ?v0) ?v1) (f22 (f23 f24 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f25 (f26 f28 ?v0) ?v1) (f25 (f26 f28 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 2))) (= (f18 (f38 f39 (f22 f48 ?v0)) ?v_0) (f18 (f38 f39 ?v0) ?v_0)))))
(assert (forall ((?v0 Real)) (let ((?v_0 (f5 f6 2))) (= (f32 (f33 f34 (f35 f49 ?v0)) ?v_0) (f32 (f33 f34 ?v0) ?v_0)))))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f20 f21 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f18 (f38 f39 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Real)) (= (f32 (f33 f34 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f25 (f26 f27 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f20 f21 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f18 (f38 f39 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Real)) (= (f32 (f33 f34 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 (f38 f39 ?v0) (f5 f6 2)))) (= (f22 f48 ?v_0) ?v_0))))
(assert (forall ((?v0 Real)) (let ((?v_0 (f32 (f33 f34 ?v0) (f5 f6 2)))) (= (f35 f49 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f22 f48 (f18 (f38 f39 ?v0) ?v1)) (f18 (f38 f39 (f22 f48 ?v0)) ?v1))))
(assert (forall ((?v0 Real) (?v1 S3)) (= (f35 f49 (f32 (f33 f34 ?v0) ?v1)) (f32 (f33 f34 (f35 f49 ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f5 f6 (* 2 ?v_0)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f18 f19 ?v0))) (= (f5 f6 (* ?v_0 2)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (= (f5 f6 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
