(set-info :smt-lib-version 2.6)
(set-logic AUFLIRA)
(set-info :source | Example extracted from Peter Baumgartner's talk at CADE-21: Logical Engineering with Instance-Based Methods.
This is a satisfiable version of the example presented during the talk.

It was translated to SMT-LIB by Leonardo de Moura |)
(set-info :category "crafted")
(set-info :status sat)
(declare-fun symmetric ((Array Int (Array Int Real)) Int) Bool)
(declare-fun n () Int)
(declare-fun a0 () (Array Int (Array Int Real)))
(declare-fun e0 () Real)
(declare-fun a1 () (Array Int (Array Int Real)))
(declare-fun e1 () Real)
(declare-fun a2 () (Array Int (Array Int Real)))
(declare-fun e2 () Real)
(declare-fun a3 () (Array Int (Array Int Real)))
(declare-fun e3 () Real)
(declare-fun a4 () (Array Int (Array Int Real)))
(declare-fun e4 () Real)
(declare-fun a5 () (Array Int (Array Int Real)))
(declare-fun e5 () Real)
(declare-fun a6 () (Array Int (Array Int Real)))
(declare-fun e6 () Real)
(declare-fun a7 () (Array Int (Array Int Real)))
(declare-fun e7 () Real)
(declare-fun a8 () (Array Int (Array Int Real)))
(declare-fun e8 () Real)
(declare-fun a9 () (Array Int (Array Int Real)))
(declare-fun e9 () Real)
(declare-fun a10 () (Array Int (Array Int Real)))
(declare-fun e10 () Real)
(declare-fun a11 () (Array Int (Array Int Real)))
(declare-fun e11 () Real)
(declare-fun a12 () (Array Int (Array Int Real)))
(declare-fun e12 () Real)
(declare-fun a13 () (Array Int (Array Int Real)))
(declare-fun e13 () Real)
(declare-fun a14 () (Array Int (Array Int Real)))
(declare-fun e14 () Real)
(declare-fun a15 () (Array Int (Array Int Real)))
(declare-fun e15 () Real)
(assert (forall ((?a (Array Int (Array Int Real))) (?n Int)) (= (symmetric ?a ?n) (forall ((?i Int) (?j Int)) (=> (and (<= 1 ?i) (<= ?i ?n) (<= 1 ?j) (<= ?j ?n)) (= (select (select ?a ?i) ?j) (select (select ?a ?j) ?i)))))))
(assert (symmetric a0 n))
(assert (= a1 (store a0 0 (store (select a0 0) 0 e0))))
(assert (= a2 (store a1 1 (store (select a1 1) 1 e1))))
(assert (= a3 (store a2 2 (store (select a2 2) 2 e2))))
(assert (= a4 (store a3 3 (store (select a3 3) 3 e3))))
(assert (= a5 (store a4 4 (store (select a4 4) 4 e4))))
(assert (= a6 (store a5 5 (store (select a5 5) 5 e5))))
(assert (= a7 (store a6 6 (store (select a6 6) 6 e6))))
(assert (= a8 (store a7 7 (store (select a7 7) 8 e7))))
(assert (= a9 (store a8 8 (store (select a8 8) 8 e8))))
(assert (= a10 (store a9 9 (store (select a9 9) 9 e9))))
(assert (= a11 (store a10 10 (store (select a10 10) 10 e10))))
(assert (= a12 (store a11 11 (store (select a11 11) 11 e11))))
(assert (= a13 (store a12 12 (store (select a12 12) 12 e12))))
(assert (= a14 (store a13 13 (store (select a13 13) 13 e13))))
(assert (= a15 (store a14 14 (store (select a14 14) 14 e14))))
(assert (not (symmetric a15 n)))
(check-sat)
(exit)
